## eccodes 2.24.2

=== src/CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#
list( APPEND grib_api_srcs
    grib_api.h
    eccodes.h
    action.c
    action_class_alias.c
    action_class_gen.c
    action_class_if.c
    action_class_switch.c
    grib_accessor_class_g1fcperiod.c
    grib_accessor_class_g1end_of_interval_monthly.c
    grib_accessor_class_mars_param.c
    action_class_section.c
    action_class_list.c
    action_class_while.c
    action_class_put.c
    action_class_meta.c
    action_class_remove.c
    action_class_rename.c
    action_class_assert.c
    action_class_template.c
    action_class_trigger.c
    action_class_when.c
    action_class_concept.c
    action_class_hash_array.c
    action_class_set.c
    action_class_set_sarray.c
    action_class_set_darray.c
    action_class_set_iarray.c
    action_class_noop.c
    action_class_write.c
    action_class_print.c
    action_class_close.c
    action_class_variable.c
    action_class_modify.c
    action_class_transient_darray.c
    eccodes.c
    grib_accessor.c
    grib_concept.c
    grib_hash_array.c
    grib_bufr_descriptor.c
    grib_bufr_descriptors_array.c
    grib_darray.c
    grib_sarray.c
    grib_oarray.c
    grib_vdarray.c
    grib_vsarray.c
    grib_iarray.c
    grib_viarray.c
    codes_memfs.c
    grib_accessor_class_array.c
    grib_accessor_class_assert.c
    grib_accessor_class_ascii.c
    grib_accessor_class_bit.c
    grib_accessor_class_bitmap.c
    grib_accessor_class_bits.c
    grib_accessor_class_bits_per_value.c
    grib_accessor_class_bufr_clear_tables.c
    grib_accessor_class_bufr_elements_table.c
    grib_accessor_class_bufr_data_array.c
    grib_accessor_class_bufr_data_element.c
    grib_accessor_class_bufr_group.c
    grib_accessor_class_bufr_string_values.c
    grib_accessor_class_pack_bufr_values.c
    grib_accessor_class_unpack_bufr_values.c
    grib_accessor_class_bufr_has_delayed_replication.c
    grib_accessor_class_apply_operators.c
    grib_accessor_class_group.c
    grib_accessor_class_non_alpha.c
    grib_accessor_class_g1bitmap.c
    grib_accessor_class_g2bitmap.c
    grib_accessor_class_concept.c
    grib_accessor_class_hash_array.c
    grib_accessor_class_decimal_precision.c
    grib_accessor_class_divdouble.c
    grib_accessor_class_budgdate.c
    grib_accessor_class_validity_date.c
    grib_accessor_class_validity_time.c
    grib_accessor_class_bytes.c
    grib_accessor_class.c
    grib_accessor_class_change_scanning_direction.c
    grib_accessor_class_check_internal_version.c
    grib_accessor_class_codeflag.c
    grib_accessor_class_smart_table.c
    grib_accessor_class_smart_table_column.c
    grib_accessor_class_codetable.c
    grib_accessor_class_codetable_units.c
    grib_accessor_class_codetable_title.c
    grib_accessor_class_step_human_readable.c
    grib_accessor_class_count_file.c
    grib_accessor_class_count_total.c
    grib_accessor_class_double.c
    grib_accessor_class_element.c
    grib_accessor_class_evaluate.c
    grib_accessor_class_g1area.c
    grib_accessor_class_g1date.c
    grib_accessor_class_g1monthlydate.c
    grib_accessor_class_library_version.c
    grib_accessor_class_when.c
    grib_accessor_class_g1verificationdate.c
    grib_accessor_class_g1day_of_the_year_date.c
    grib_accessor_class_g1_half_byte_codeflag.c
    grib_accessor_class_g1forecastmonth.c
    grib_accessor_class_g1step_range.c
    grib_accessor_class_g2step_range.c
    grib_accessor_class_data_g22order_packing.c
    grib_accessor_class_mars_step.c
    grib_accessor_class_message_copy.c
    grib_accessor_class_dictionary.c
    grib_accessor_class_g1param.c
    grib_accessor_class_g1p1p2.c
    grib_accessor_class_g1_increment.c
    grib_accessor_class_latlon_increment.c
    grib_accessor_class_g2date.c
    grib_accessor_class_g2level.c
    grib_accessor_class_g2step.c
    grib_accessor_class_g2end_step.c
    grib_accessor_class_g2latlon.c
    grib_accessor_class_g2lon.c
    grib_accessor_class_global_gaussian.c
    grib_accessor_class_gaussian_grid_name.c
    grib_accessor_class_gen.c
    grib_accessor_class_getenv.c
    grib_accessor_class_gts_header.c
    grib_accessor_class_ifs_param.c
    grib_accessor_class_julian_day.c
    grib_accessor_class_julian_date.c
    grib_accessor_class_latlonvalues.c
    grib_accessor_class_latitudes.c
    grib_accessor_class_longitudes.c
    grib_accessor_class_missing.c
    grib_accessor_class_offset_file.c
    grib_accessor_class_scale.c
    grib_accessor_class_from_scale_factor_scaled_value.c
    grib_accessor_class_times.c
    grib_accessor_class_forward.c
    grib_accessor_class_g2bitmap_present.c
    grib_accessor_class_ibmfloat.c
    grib_accessor_class_ieeefloat.c
    grib_accessor_class_constant.c
    grib_accessor_class_iterator.c
    grib_accessor_class_message.c
    grib_accessor_class_nearest.c
    grib_accessor_class_box.c
    grib_accessor_class_ksec1expver.c
    grib_accessor_class_laplacian.c
    grib_accessor_class_label.c
    grib_accessor_class_long.c
    grib_accessor_class_lookup.c
    grib_accessor_class_octahedral_gaussian.c
    grib_accessor_class_octect_number.c
    grib_accessor_class_headers_only.c
    grib_accessor_class_padding.c
    grib_accessor_class_pad.c
    grib_accessor_class_padto.c
    grib_accessor_class_padtoeven.c
    grib_accessor_class_padtomultiple.c
    grib_accessor_class_section_padding.c
    grib_accessor_class_section_pointer.c
    grib_accessor_class_position.c
    grib_accessor_class_signed.c
    grib_accessor_class_signed_bits.c
    grib_accessor_class_section.c
    grib_accessor_class_step_in_units.c
    grib_accessor_class_section_length.c
    grib_accessor_class_g1_message_length.c
    grib_accessor_class_g1_section4_length.c
    grib_accessor_class_size.c
    grib_accessor_class_rdbtime_guess_date.c
    grib_accessor_class_scale_values.c
    grib_accessor_class_offset_values.c
    grib_accessor_class_sprintf.c
    grib_accessor_class_round.c
    grib_accessor_class_spectral_truncation.c
    grib_accessor_class_time.c
    grib_accessor_class_transient.c
    grib_accessor_class_trim.c
    grib_accessor_class_transient_darray.c
    grib_accessor_class_values.c
    grib_accessor_class_simple_packing_error.c
    grib_accessor_class_data_simple_packing.c
    grib_accessor_class_count_missing.c
    grib_accessor_class_data_sh_packed.c
    grib_accessor_class_data_sh_unpacked.c
    grib_accessor_class_number_of_values_data_raw_packing.c
    grib_accessor_class_data_g1simple_packing.c
    grib_accessor_class_data_g1shsimple_packing.c
    grib_accessor_class_data_shsimple_packing.c
    grib_accessor_class_data_constant_field.c
    grib_accessor_class_data_dummy_field.c
    grib_2order_packer_simple.c
    grib_accessor_class_variable.c
    grib_accessor_class_second_order_bits_per_value.c
    grib_accessor_class_data_g2simple_packing.c
    grib_accessor_class_data_g2simple_packing_with_preprocessing.c
    grib_accessor_class_data_g2shsimple_packing.c
    grib_accessor_class_data_g2complex_packing.c
    grib_accessor_class_data_2order_packing.c
    grib_accessor_class_data_2order_packing_count.c
    grib_accessor_class_data_g1second_order_row_by_row_packing.c
    grib_accessor_class_data_g1second_order_constant_width_packing.c
    grib_accessor_class_data_g1second_order_general_packing.c
    grib_accessor_class_data_g1second_order_general_extended_packing.c
    grib_accessor_class_g2grid.c
    grib_accessor_class_unexpanded_descriptors.c
    grib_accessor_class_expanded_descriptors.c
    grib_accessor_class_bufrdc_expanded_descriptors.c
    grib_accessor_class_data_apply_bitmap.c
    grib_accessor_class_data_apply_boustrophedonic.c
    grib_accessor_class_data_apply_boustrophedonic_bitmap.c
    grib_accessor_class_data_secondary_bitmap.c
    grib_accessor_class_data_g1secondary_bitmap.c
    grib_accessor_class_data_g2secondary_bitmap.c
    grib_accessor_class_data_jpeg2000_packing.c
    grib_accessor_class_data_png_packing.c
    grib_accessor_class_data_ccsds_packing.c
    grib_accessor_class_data_raw_packing.c
    grib_accessor_class_data_complex_packing.c
    grib_accessor_class_data_g1complex_packing.c
    grib_accessor_class_gds_not_present_bitmap.c
    grib_accessor_class_data_apply_gdsnotpresent.c
    grib_accessor_class_gds_is_present.c
    grib_accessor_class_select_step_template.c
    grib_accessor_class_local_definition.c
    grib_accessor_class_g2_eps.c
    grib_accessor_class_g2_aerosol.c
    grib_accessor_class_g2_chemical.c
    grib_accessor_class_g2_mars_labeling.c
    grib_accessor_class_md5.c
    grib_accessor_class_proj_string.c
    grib_jasper_encoding.c
    grib_openjpeg_encoding.c
    action_class_set_missing.c
    grib_accessor_class_number_of_points.c
    grib_accessor_class_suppressed.c
    grib_index.c
    grib_accessor_class_number_of_points_gaussian.c
    grib_accessor_class_number_of_values.c
    grib_accessor_class_number_of_coded_values.c
    grib_accessor_class_g1number_of_coded_values_sh_complex.c
    grib_accessor_class_g1number_of_coded_values_sh_simple.c
    grib_accessor_class_dirty.c
    grib_accessor_class_statistics.c
    grib_accessor_class_statistics_spectral.c
    grib_accessor_class_unsigned.c
    grib_accessor_class_unsigned_bits.c
    grib_accessor_class_raw.c
    grib_accessor_class_bufr_simple_thinning.c
    grib_accessor_class_bufr_extract_subsets.c
    grib_accessor_class_bufr_extract_area_subsets.c
    grib_accessor_class_bufr_extract_datetime_subsets.c
    grib_accessor_class_spd.c
    grib_accessor_class_sum.c
    grib_accessor_class_to_integer.c
    grib_accessor_class_to_double.c
    grib_accessor_class_to_string.c
    grib_accessor_class_sexagesimal2decimal.c
    grib_accessor_class_vector.c
    grib_accessor_class_long_vector.c
    grib_gaussian_reduced.c
    grib_accessor_class_abstract_vector.c
    grib_accessor_class_abstract_long_vector.c
    grib_loader_from_handle.c
    grib_bits.c
    grib_timer.c
    grib_ibmfloat.c
    grib_ieeefloat.c
    grib_accessor_class_reference_value_error.c
    grib_memory.c
    grib_buffer.c
    grib_dumper.c
    grib_dumper_class_serialize.c
    grib_dumper_class_debug.c
    grib_dumper_class_default.c
    grib_dumper_class_keys.c
    grib_dumper_class_bufr_encode_C.c
    grib_dumper_class_bufr_encode_filter.c
    grib_dumper_class_bufr_encode_fortran.c
    grib_dumper_class_bufr_encode_python.c
    grib_dumper_class_bufr_decode_C.c
    grib_dumper_class_bufr_decode_filter.c
    grib_dumper_class_bufr_decode_fortran.c
    grib_dumper_class_bufr_decode_python.c
    grib_dumper_class_bufr_simple.c
    grib_dumper_class_json.c
    grib_dumper_class_grib_encode_C.c
    grib_dumper_class_wmo.c
    grib_dumper_class.c
    grib_context.c
    grib_date.c
    grib_fieldset.c
    grib_filepool.c
    grib_geography.c
    grib_handle.c
    grib_header_compute.c
    grib_hash_keys.c
    grib_io.c
    grib_trie.c
    grib_trie_with_rank.c
    grib_itrie.c
    grib_rules.c
    grib_keys_iterator.c
    bufr_keys_iterator.c
    grib_parse_utils.c
    grib_query.c
    grib_scaling.c
    grib_templates.c
    grib_dependency.c
    grib_value.c
    grib_errors.c
    grib_expression_class_binop.c
    grib_expression_class_logical_and.c
    grib_expression_class_logical_or.c
    grib_expression_class_is_in_dict.c
    grib_expression_class_true.c
    grib_expression_class_string_compare.c
    grib_expression_class_unop.c
    grib_expression_class_functor.c
    grib_expression_class_accessor.c
    grib_expression_class_is_in_list.c
    grib_expression_class_is_integer.c
    grib_expression_class_length.c
    grib_expression_class_long.c
    grib_expression_class_double.c
    grib_expression_class_string.c

=== tigge/CMakeLists.txt ===
# tigge

# library
ecbuild_add_library(TARGET    tigge_tools
                    TYPE      STATIC
                    NOINSTALL
                    SOURCES   tigge_tools.c tigge_tools.h)

# executables
ecbuild_add_executable(TARGET   tigge_check
                       SOURCES  tigge_check.c
                       INCLUDES ${ECCODES_EXTRA_INCLUDE_DIRS}
                       LIBS     eccodes tigge_tools)

ecbuild_add_executable(TARGET     tigge_name
                       SOURCES    tigge_name.c
                       INCLUDES   ${ECCODES_EXTRA_INCLUDE_DIRS}
                       CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                       LIBS       eccodes tigge_tools)

ecbuild_add_executable(TARGET     tigge_accumulations
                       SOURCES    tigge_accumulations.c
                       INCLUDES   ${ECCODES_EXTRA_INCLUDE_DIRS}
                       CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                       LIBS       eccodes tigge_tools)

ecbuild_add_executable(TARGET     tigge_split
                       SOURCES    tigge_split.c
                       INCLUDES   ${ECCODES_EXTRA_INCLUDE_DIRS}
                       CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                       LIBS       eccodes tigge_tools)

=== tools/CMakeLists.txt ===
#
# (C) Copyright 2005- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.
#

list( APPEND grib_tools_sources
             grib_tools.c
             grib_options.c
             grib_tools.h )

if( EC_OS_NAME MATCHES "windows" )
  list( APPEND grib_tools_sources wingetopt.c )
endif()

# tools library
ecbuild_add_library( TARGET    grib_tools
                     TYPE      STATIC
                     NOINSTALL
                     SOURCES   ${grib_tools_sources}
                     PRIVATE_LIBS      eccodes )

# tools binaries
list( APPEND ecc_tools_binaries
             codes_info codes_count codes_split_file
             grib_histogram grib_filter grib_ls grib_dump grib_merge
             grib2ppm grib_set grib_get grib_get_data grib_copy
             grib_compare codes_parser grib_index_build bufr_index_build
             bufr_ls bufr_dump bufr_set bufr_get
             bufr_copy bufr_compare
             gts_get gts_compare gts_copy gts_dump gts_filter gts_ls
             metar_dump metar_ls metar_compare metar_get metar_filter metar_copy )

list( APPEND ecc_tools_binaries_extra
             big2gribex
             gg_sub_area_check
             grib_repair
             grib_to_json
             grib_check_gaussian_grid
             bufr_split_by_rdbSubtype )

# Install generic tools
foreach( tool ${ecc_tools_binaries} )
    # here we use the fact that each tool has only one C file that matches its name
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.c
                            LIBS       grib_tools )
endforeach()

# Install extra tools
# User must run cmake with -DECCODES_INSTALL_EXTRA_TOOLS=ON
foreach( tool ${ecc_tools_binaries_extra} )
    ecbuild_add_executable( TARGET     ${tool}
                            SOURCES    ${tool}.c
                            CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                            LIBS       grib_tools )
endforeach()

# grib_count/bufr_count etc. Same source code, different executable names
ecbuild_add_executable( TARGET     grib_count
                        SOURCES    codes_count.c
                        LIBS       grib_tools )
ecbuild_add_executable( TARGET     bufr_count
                        SOURCES    codes_count.c
                        LIBS       grib_tools )
ecbuild_add_executable( TARGET     gts_count
                        SOURCES    codes_count.c
                        LIBS       grib_tools )

# grib to netcdf is optional
ecbuild_add_executable( TARGET     grib_to_netcdf
                        SOURCES    grib_to_netcdf.c
                        CONDITION  HAVE_NETCDF
                        LIBS       grib_tools NetCDF::NetCDF_C )


ecbuild_add_executable( TARGET     grib_list_keys
                        SOURCES    list_keys.c
                        CONDITION  ECCODES_INSTALL_EXTRA_TOOLS
                        LIBS       grib_tools )

ecbuild_add_executable( TARGET     codes_bufr_filter
                        SOURCES    bufr_filter.c
                        LIBS       grib_tools )


# grib1to2 script needs to be generated before installation
if( ECCODES_INSTALL_EXTRA_TOOLS )
    ecbuild_info("ECCODES_INSTALL_EXTRA_TOOLS enabled")
    configure_file( grib1to2.in  grib1to2 )
    install( FILES ${CMAKE_CURRENT_BINARY_DIR}/grib1to2
             DESTINATION ${INSTALL_BIN_DIR}
             PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                         GROUP_EXECUTE GROUP_READ
                         WORLD_EXECUTE WORLD_READ )
endif()
########################################

# BUFR compare script
install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_compare_dir
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )


# bufr_filter script (See ECC-205)
execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different
    ${PROJECT_SOURCE_DIR}/tools/bufr_filter
    ${CMAKE_BINARY_DIR}/bin/ )

install( FILES ${CMAKE_CURRENT_SOURCE_DIR}/bufr_filter
         DESTINATION ${INSTALL_BIN_DIR}
         PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                     GROUP_EXECUTE GROUP_READ
                     WORLD_EXECUTE WORLD_READ )

=== data/bufr/CMakeLists.txt ===
# data/bufr/CMakeLists.txt
# Download all the BUFR data and reference files from website
#

file(READ "bufr_data_files.txt" bufr_files_to_download)
# Convert file contents into a CMake list (where each element in the list
# is one line of the file)
string(REGEX REPLACE "\n" ";" bufr_files_to_download "${bufr_files_to_download}")


file(READ "bufr_ref_files.txt" bufr_refs_to_download)
string(REGEX REPLACE "\n" ";" bufr_refs_to_download "${bufr_refs_to_download}")

# Exceptional case: download bufr files which have to be treated specially
list(APPEND bufr_refs_to_download "vos308014_v3_26.bufr")  # See test ecc-197

if( ENABLE_EXTRA_TESTS )
    ecbuild_get_test_multidata(
         TARGET eccodes_download_bufrs
         NOCHECK
        NAMES ${bufr_files_to_download} ${bufr_refs_to_download}
    )
endif()

# Copy other files - e.g. text files etc from the source data/bufr dir
list(APPEND other_files
    bufr_data_files.txt
    bufr_ref_files.txt
)

foreach( file ${other_files} )
   execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR} )
endforeach()

=== examples/C/CMakeLists.txt ===
# examples/C/CMakeLists.txt

# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh  @ONLY )

execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/include.sh ${CMAKE_CURRENT_BINARY_DIR} )

# Build the executables used by test scripts
#############################################
list( APPEND test_bins
      grib_nearest
      grib_set_bitmap
      grib_iterator
      grib_get_keys
      grib_print_data
      grib_set_keys
      grib_index
      grib_set_missing
      grib_keys_iterator
      grib_set_data
      mars_param
      values_check
      box
      grib_nearest_multiple
      grib_multi
      multi2
      grib_multi_write
      grib_precision
      grib_set_pv
      grib_list
      grib_get_data
      grib_sections_copy
      grib_iterator_bitmap
      large_grib1
      grib_clone
      grib_copy_message
      grib_ensemble_index
      get_product_kind
      bufr_copy_data
      bufr_attributes
      bufr_clone
      bufr_expanded
      bufr_get_keys
      bufr_get_string_array
      bufr_keys_iterator
      bufr_missing
      bufr_read_header
      bufr_read_scatterometer
      bufr_read_synop
      bufr_read_temp
      bufr_set_keys
      bufr_subset )

foreach( tool ${test_bins} )
    ecbuild_add_executable( TARGET    c_${tool}
                            NOINSTALL
                            SOURCES   ${tool}.c
                            LIBS      eccodes )
endforeach()

# Now add each test (shell scripts)
####################################
if( HAVE_BUILD_TOOLS )
    # Command line tools are available
    list(APPEND tests_sanity
         grib_set_data
         large_grib1
         grib_sections_copy
         get_product_kind_samples)
    list(APPEND tests_extra
       grib_iterator
       grib_get_keys
       grib_print_data
       grib_set_keys
       grib_keys_iterator
       grib_multi_write
       grib_precision
       grib_clone
       grib_copy_message
       grib_ensemble_index
       grib_set_pv
       grib_set_bitmap
       grib_list
       grib_get_data
       grib_nearest_multiple
       grib_multi
       grib_set_missing
       bufr_attributes
       bufr_copy_data
       bufr_clone
       bufr_expanded
       bufr_get_keys
       bufr_get_string_array
       bufr_keys_iterator
       bufr_missing
       bufr_read_header
       bufr_read_scatterometer
       bufr_read_synop
       bufr_read_temp
       bufr_set_keys
       bufr_subset
       get_product_kind)
else()
    # No command line tools
    list(APPEND tests_sanity
        grib_set_data
        get_product_kind_samples)
    list(APPEND tests_extra
       grib_iterator
       grib_get_keys
       grib_print_data
       grib_set_keys
       grib_keys_iterator
       grib_precision
       grib_ensemble_index
       grib_set_pv
       grib_list
       grib_get_data
       grib_nearest_multiple
       grib_multi
       grib_set_missing
       bufr_attributes
       bufr_expanded
       bufr_get_keys
       bufr_get_string_array
       bufr_keys_iterator
       bufr_missing
       bufr_read_header
       bufr_read_scatterometer
       bufr_read_synop
       bufr_read_temp
       bufr_set_keys
       bufr_subset
       get_product_kind)
endif()

foreach( test ${tests_sanity} )
        ecbuild_add_test( TARGET       eccodes_c_${test}
                          TYPE         SCRIPT
                          LABELS       "sanity"
                          COMMAND      ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh )
endforeach()
foreach( test ${tests_extra} )
        ecbuild_add_test( TARGET       eccodes_c_${test}
                          TYPE         SCRIPT
                          CONDITION    ENABLE_EXTRA_TESTS
                          COMMAND      ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                          TEST_DEPENDS eccodes_download_gribs eccodes_download_bufrs )
endforeach()

# Tests which are conditional
#############################
if( ENABLE_EXTRA_TESTS AND HAVE_ECCODES_THREADS )
    # For POSIX threads
    list(APPEND pthread_tests grib_pthreads bufr_pthreads)
    foreach( test ${pthread_tests} )
        ecbuild_add_executable( TARGET    c_${test}
                                NOINSTALL
                                SOURCES   ${test}.c
                                LIBS      eccodes ${CMAKE_THREAD_LIBS_INIT} )
        ecbuild_add_test( TARGET       eccodes_c_${test}
                          TYPE         SCRIPT
                          COMMAND      ${CMAKE_CURRENT_SOURCE_DIR}/${test}.sh
                          TEST_DEPENDS eccodes_download_gribs eccodes_download_bufrs )
    endforeach()
endif()

# Tests with no script
######################
ecbuild_add_test(
    TARGET    eccodes_c_new_sample
    SOURCES   new_sample.c
    LIBS      eccodes
    ARGS      "out.grib"
    ENVIRONMENT "ECCODES_SAMPLES_PATH=${PROJECT_SOURCE_DIR}/samples" "ECCODES_DEFINITION_PATH=${PROJECT_SOURCE_DIR}/definitions"
)

=== examples/F90/CMakeLists.txt ===
# examples/F90/CMakeLists.txt

# Configure the file which all CMake tests will include
configure_file( include.ctest.sh.in  include.ctest.sh  @ONLY )

execute_process( COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/include.sh ${CMAKE_CURRENT_BINARY_DIR} )

# Add all the tests
####################
if( HAVE_BUILD_TOOLS )
    list( APPEND tests_sanity
          grib_set_pv
          grib_set_data
          bufr_ecc-1284
          grib_ecc-671 )
    list( APPEND tests_extra
          grib_index
          grib_copy_message
          bufr_copy_message
          grib_get_keys
          grib_get_data
          grib_get_pl
          grib_get_pv
          grib_keys_iterator
          grib_multi_write
          grib_multi
          grib_nearest
          grib_precision
          grib_print_data
          grib_set_keys
          grib_set_bitmap
          grib_set_missing
          grib_samples
          grib_count_messages
          grib_count_messages_multi
          grib_copy_namespace
          grib_read_message
          grib_read_from_file
          grib_get_set_uuid
          grib_clone
          bufr_attributes
          bufr_copy_data
          bufr_clone
          bufr_expanded
          bufr_get_keys
          bufr_get_string_array
          bufr_keys_iterator
          bufr_read_header
          bufr_read_scatterometer
          bufr_read_synop
          bufr_read_temp
          bufr_read_tempf
          bufr_read_tropical_cyclone
          bufr_set_keys
          bufr_copy_keys
          bufr_subset
          get_product_kind )
else()
    # No command line tools
    list( APPEND tests_sanity
          grib_set_pv
          grib_set_data
          grib_ecc-671 )
    list( APPEND tests_extra
          grib_index
          grib_get_keys
          grib_get_data
          grib_get_pl
          grib_get_pv
          grib_keys_iterator
          grib_multi
          grib_nearest
          grib_precision
          grib_print_data
          grib_set_missing
          grib_samples
          grib_count_messages
          grib_count_messages_multi
          grib_read_from_file
          grib_clone
          bufr_attributes
          bufr_clone
          bufr_expanded
          bufr_get_keys
          bufr_get_string_array
          bufr_keys_iterator
          bufr_read_header
          bufr_read_scatterometer
          bufr_read_synop
          bufr_read_temp
          bufr_read_tempf
          bufr_read_tropical_cyclone
          bufr_set_keys
          bufr_subset
          get_product_kind )
endif()

foreach( tool ${tests_sanity} )
    ecbuild_add_test( TARGET          eccodes_f_${tool}
                      SOURCES         ${tool}.f90
                      LINKER_LANGUAGE Fortran
                      LIBS            eccodes_f90 eccodes
                      CONDITION       HAVE_FORTRAN
                      LABELS          "sanity"
                      RESOURCES       bufr_read_scatterometer_f.ref
                      COMMAND         ${CMAKE_CURRENT_SOURCE_DIR}/${tool}.sh )
endforeach()
foreach( tool ${tests_extra} )
    ecbuild_add_test( TARGET          eccodes_f_${tool}
                      SOURCES         ${tool}.f90
                      LINKER_LANGUAGE Fortran
                      LIBS            eccodes_f90 eccodes
                      CONDITION       HAVE_FORTRAN AND ENABLE_EXTRA_TESTS
                      RESOURCES       bufr_read_scatterometer_f.ref
                      COMMAND         ${CMAKE_CURRENT_SOURCE_DIR}/${tool}.sh
                      TEST_DEPENDS    eccodes_download_gribs eccodes_download_bufrs )
endforeach()

# Test for CCSDS (AEC) packing
ecbuild_add_test( TARGET          eccodes_f_grib_set_packing
                  SOURCES         grib_set_packing.f90
                  LINKER_LANGUAGE Fortran
                  LIBS            eccodes_f90 eccodes
                  CONDITION       HAVE_AEC AND HAVE_FORTRAN
                  COMMAND         ${CMAKE_CURRENT_SOURCE_DIR}/grib_set_packing.sh )

# Executables without a shell script
ecbuild_add_executable( TARGET    eccodes_f_new_from_file
                        NOINSTALL
                        SOURCES   new_from_file.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes )
ecbuild_add_executable( TARGET    eccodes_f_grib_set_gvc
                        NOINSTALL
                        SOURCES   grib_set_gvc.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes )
ecbuild_add_executable( TARGET    eccodes_f_grib_print_data_static
                        NOINSTALL
                        SOURCES   grib_print_data_static.f90
                        CONDITION HAVE_FORTRAN
                        LINKER_LANGUAGE Fortran
                        LIBS      eccodes_f90 eccodes )


# # Note extra dependency
# ecbuild_add_test( TARGET eccodes_f_set_test
#                   TYPE SCRIPT
#                   DEPENDS set_gvc set
#                   COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/set.sh
# )

=== ifs_samples/grib1/CMakeLists.txt ===
set( _basedir grib1 )
set( _destination_install ${ECCODES_IFS_SAMPLES_SUFF}/${_basedir} )
set( _destination_build   ${CMAKE_BINARY_DIR}/${ECCODES_IFS_SAMPLES_SUFF}/${_basedir} )

list( APPEND ifs_samples_${_basedir}
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_ml.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_sfc.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/sh_ml.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/sh_sfc.tmpl
      ${ECCODES_SAMPLES_FILES} )

install_samples( ifs_samples_${_basedir} ${_destination_install} ${_destination_build} )

=== ifs_samples/grib1_mlgrib2/CMakeLists.txt ===
set( _basedir grib1_mlgrib2 )
set( _destination_install ${ECCODES_IFS_SAMPLES_SUFF}/${_basedir} )
set( _destination_build   ${CMAKE_BINARY_DIR}/${ECCODES_IFS_SAMPLES_SUFF}/${_basedir} )

list( APPEND ifs_samples_${_basedir}
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_ml.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_sfc.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/sh_ml.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/sh_sfc.tmpl
      ${ECCODES_SAMPLES_FILES} )

install_samples( ifs_samples_${_basedir} ${_destination_install} ${_destination_build} )

=== ifs_samples/grib1_mlgrib2_ieee32/CMakeLists.txt ===
set( _basedir grib1_mlgrib2_ieee32 )
set( _destination_install ${CMAKE_INSTALL_PREFIX}/${ECCODES_IFS_SAMPLES_SUFF}/${_basedir} )
set( _destination_build   ${CMAKE_BINARY_DIR}/${ECCODES_IFS_SAMPLES_SUFF}/${_basedir} )

list( APPEND ifs_samples_${_basedir}
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_ml.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/gg_sfc.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/sh_ml.tmpl
      ${CMAKE_CURRENT_SOURCE_DIR}/sh_sfc.tmpl
      ${ECCODES_SAMPLES_FILES} )

install_samples( ifs_samples_${_basedir} ${_destination_install} ${_destination_build} )

=== debian/changelog ===
eccodes (2.24.2-1) unstable; urgency=medium

  * New upstream release
  * Drop obsolete gfortran-10.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 21 Jan 2022 10:56:37 +0000

eccodes (2.24.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 13 Jan 2022 12:08:51 +0000

eccodes (2.24.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 08 Dec 2021 14:54:42 +0000

eccodes (2.23.0-2) unstable; urgency=medium

  * Rebuild against gfortran-11 to provide grib_api.mod

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 11 Oct 2021 13:01:15 +0100

eccodes (2.23.0-1.1) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Fix 'Flow control statements are not properly nested' error.
    (closes: #995328)

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 30 Sep 2021 08:52:35 +0100

eccodes (2.23.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 28 Aug 2021 09:51:07 +0100

=== debian/control ===
Source: eccodes
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-buildinfo, 
  dh-sequence-fortran-mod,
  gfortran | fortran-compiler, 
  ecbuild (>= 3.3.0-2),
  libjpeg-dev, 
  libpng-dev, 
  flex, 
  bison, 
  quilt,
  swig, 
  doxygen,
  libboost-dev, 
  libhdf5-dev, 
  chrpath,
  libaec-dev,
  libnetcdf-dev,
  libopenjp2-7-dev
Build-Conflicts: libopenjpeg-dev, libgrib-api-dev
Standards-Version: 4.6.0
Homepage: https://software.ecmwf.int/wiki/display/ECC/ecCodes+Home
Vcs-Browser: https://salsa.debian.org:/science-team/eccodes.git
Vcs-Git: https://salsa.debian.org:/science-team/eccodes.git -b debian/latest

Package: libeccodes0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libeccodes-data
Description: GRIB and BUFR enecoding/encoding software library
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 It is a replacement for the grib-api and emoslib libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: GRIB and BUFR enecoding/encoding software library - data
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 
Package: libeccodes-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeccodes0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
  libaec-dev, libpng-dev, libjpeg-dev, zlib1g-dev
Conflicts: libgrib-api-dev
Description: GRIB and BUFR decoding/encoding software library (development)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
 
Package: libeccodes-tools
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mksh | pdksh | zsh | ksh
Conflicts: libgrib-api-tools
Breaks: libemos-bin (<< 2:4.4.5-2)
Description: GRIB decoding/encoding software (utilities)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This is a useful set of command line tools to give quick access to grib
 messages.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeccodes-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, libjs-jquery
Description: GRIB decoding/encoding software (documentation)
 ecCodes is the ECMWF encoding/decoding software for GRIB and BUFR.
 .
 This provides the documentation for the library.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.
